/* 
 * (c) Poznan University of Technology
 * File name: FramsClient3D.java.
 * Created on 2003-10-04 21:51:59.
 */
 
package frams_client_3d;
import java.io.BufferedReader;
import java.io.IOException;
import java.io.InputStreamReader;
import java.io.PrintWriter;
import java.net.InetAddress;
import java.net.Socket;
import java.net.UnknownHostException;

/**
 * Server communication console tester.
 * @author <a href="mailto:momat@man.poznan.pl">MoMaT</a>
 */
public class Communication_test {
	static String host;
	static int port = 9009;
	 	
	public static void main(String[] args) throws IOException {
		
		Socket socket = null;
		PrintWriter out = null;
		BufferedReader in = null;				
		
		//initiate socket connection
		try {
			host = InetAddress.getLocalHost().getHostAddress();
			socket = new Socket(host, port);
			out = new PrintWriter(socket.getOutputStream(), true);
			in = new BufferedReader(new InputStreamReader(
										socket.getInputStream()));
		} catch (UnknownHostException e) {
			System.err.println("Unknown host: "+host);
			System.exit(1);
		} catch (IOException e) {
			System.err.println("Couldn't get I/O for the connection to "+host);
			System.exit(1);
		}

		String message;
		
		//send server version	
		try {
			out.println("version 2\n");
			message = in.readLine();			
			System.out.println(message);
		} catch(IOException e) {
			e.printStackTrace();
			System.exit(1);
		}
				
		String userInput;		
		BufferedReader stdIn = new BufferedReader(new InputStreamReader(System.in));									
	
		try {		
			while (!(userInput = stdIn.readLine()).equals("quit")) {		
				//send command to server
				out.println(userInput);
				//read server answer			
				while ((message = in.readLine()) != null) {				
					System.out.println(host+": "+message);
					//stop if reading complete
					if(message.startsWith("ok") || message.startsWith("error")) {
						break;
					}					
				}
			}
		} catch (IOException e) {
			System.err.println("I/O error: "+e.getMessage());
			System.exit(1);	
		}
		
		try { 
			out.close();
			in.close();
			stdIn.close();
			socket.close();
		} catch (IOException e) {
			System.err.println("Stream closing error: "+e.getMessage());
			System.exit(1);	
		}
	}
}
